CFPRIME ISTAB4                                                          ISTAB4      1
C***********************************************************************RIGHTE      1
C*                                                                     *RIGHTE      2
C*        Extended Transient-Midterm Stability Program (ETMSP)         *RIGHTE      3
C*        ====================================================         *RIGHTE      4
C*                                                                     *RIGHTE      5
C*       Copyright (C) (1993) Electric Power Research Institute        *RIGHTE      6
C*                                                                     *RIGHTE      7
C* EPRI reserves all rights in the software and associated             *RIGHTE      8
C* documentation as delivered. The software and its associated         *RIGHTE      9
C* documention or any portion thereof may not be reproduced in any form*RIGHTE     10
C* whatsoever without the consent of EPRI, except as explicity provided*RIGHTE     11
C* for by license. Licensee shall submit a detailed description to EPRI*RIGHTE     12
C* of any changes or modifications to the software within two (2)      *RIGHTE     13
C* months after such changes or modifications are made. At EPRI's sole *RIGHTE     14
C* discretion, the software, as changed or modified, shall be given a  *RIGHTE     15
C* new designation sufficiently different from its then current        *RIGHTE     16
C* designation as to prevent mistake,confusion, or deception as between*RIGHTE     17
C* the current software as changed or modified.                        *RIGHTE     18
C*                                                                     *RIGHTE     19
C* A license under EPRI's rights in the software can be obtained       *RIGHTE     20
C* directly from EPRI.                                                 *RIGHTE     21
C*                                                                     *RIGHTE     22
C* This program and supporting materials may be independently available*RIGHTE     23
C* from Electric Power Software centre (EPSC) for an appropriate       *RIGHTE     24
C* distribution fee. The EPSC is a service of                          *RIGHTE     25
C*                                                                     *RIGHTE     26
C*                    Power Computing Company                          *RIGHTE     27
C*                    1930 Hi Line                                     *RIGHTE     28
C*                    Dallas, Tx 75207                                 *RIGHTE     29
C*                                                                     *RIGHTE     30
C* NEITHER EPRI, ANY MEMBER OF EPRI, NOR ANY PERSON OR  ORGANIZATION   *RIGHTE     31
C* ACTING ON BEHAVE OF THEM:                                           *RIGHTE     32
C*                                                                     *RIGHTE     33
C* 1. MAKE ANY WARRANTY OR REPRESENTATION WHATSOEVER, EXPRESS OR       *RIGHTE     34
C*    IMPLIED, INCLUDING ANY WARRANTY OF MERCHANTABILITY OR FITNESS OR *RIGHTE     35
C*    ANY PURPOSE WITH RESPECT TO THE SOFTWARE OR ITS ASSOCIATED       *RIGHTE     36
C*    DOCUMENTATION; OR                                                *RIGHTE     37
C*                                                                     *RIGHTE     38
C* 2. ASSUMES ANY LIABILITY WHATSOEVER WITH RESPECT TO ANY USE OF THE  *RIGHTE     39
C*    SOFTWARE OR ITS ASSOCIATED DOCUMENTATION OR ANY PORTION THEREOF  *RIGHTE     40
C*    OR WITH RESPECT TO ANY DAMAGES WHICH MAY RESULT FROM SUCH USE.   *RIGHTE     41
C*                                                                     *RIGHTE     42
C* THIS NOTICE MAY NOT BE REMOVED FROM THE SOFTWARE BY ANY USER        *RIGHTE     43
C* THEREOF.                                                            *RIGHTE     44
C*                                                                     *RIGHTE     45
C***********************************************************************RIGHTE     46
      SUBROUTINE ISTAB4(ISMAX,ISMIN)                                    ISTAB4      3
CD                                                                      ISTAB4      4
CD    TO PERFORM INITIALIZATION AND DATA CHECK FOR STABILIZER TYPES     ISTAB4      5
CD    4, 5, 6 AND 7.                                                    ISTAB4      6
CD                                                                      ISTAB4      7
CD    THE DATA STRUCTURE AFTER THE INITIALIZATION IS GIVEN BELOW.       ISTAB4      8
CD                                                                      ISTAB4      9
CD   4.4 Stabilizer type 4                                              ISTAB4     10
CD                                                                      ISTAB4     11
CD     Stabilizer data                                                  ISTAB4     12
CD                                                                      ISTAB4     13
CD     IDDAT(JS+1)    = BUSR         : sensing bus number               ISTAB4     14
CD     IDDAT(JS+2)    = TYPE         : type of input signal:            ISTAB4     15
CD                                     = 1 rotor speed                  ISTAB4     16
CD                                     = 2 acceleration power           ISTAB4     17
CD                                     = 3 bus frequency                ISTAB4     18
CD                                     = 4 electrical power             ISTAB4     19
CD                                     = 5 bus voltage magnitude        ISTAB4     20
CD                                     = 6 voltage deviation from steadyISTAB4     21
CD                                        state value                   ISTAB4     22
CD     DDAT(JS+ 3)    = KS                                              ISTAB4     23
CD     DDAT(JS+ 4)    = T5                                              ISTAB4     24
CD     DDAT(JS+ 5)    = T1                                              ISTAB4     25
CD     DDAT(JS+ 6)    = T2                                              ISTAB4     26
CD     DDAT(JS+ 7)    = T3                                              ISTAB4     27
CD     DDAT(JS+ 8)    = T4                                              ISTAB4     28
CD     DDAT(JS+ 9)    = VSMAX                                           ISTAB4     29
CD     DDAT(JS+10)    = VSMIN                                           ISTAB4     30
CD     DDAT(JS+11)    = TF                                              ISTAB4     31
CD     DDAT(JS+12)    = RC                                              ISTAB4     32
CD     DDAT(JS+13)    = XC                                              ISTAB4     33
CD     DDAT(JS+14)    = PTHR                                            ISTAB4     34
CD                                                                      ISTAB4     35
CD     Stabilizer states                                                ISTAB4     36
CD                                                                      ISTAB4     37
CD     XSTATE(JSS+1)  = TF block if input is bus frequency              ISTAB4     38
CD                                                  : optional          ISTAB4     39
CD     XSTATE(JSS+2)  = T5 block                    : compulsory        ISTAB4     40
CD     XSTATE(JSS+3)  = first state of T2/T4 block  : optional          ISTAB4     41
CD     XSTATE(JSS+4)  = second state of T2/T4 block : optional          ISTAB4     42
CD                                                                      ISTAB4     43
CD     Stabilizer Y-variables                                           ISTAB4     44
CD                                                                      ISTAB4     45
CD     VSS(JYS+1)     = stabilizer output                               ISTAB4     46
CD                                                                      ISTAB4     47
CD   4.5 Stabilizer type 5                                              ISTAB4     48
CD                                                                      ISTAB4     49
CD     Stabilizer data                                                  ISTAB4     50
CD                                                                      ISTAB4     51
CD     IDDAT(JS+1)    = BUSR         : sensing bus number               ISTAB4     52
CD     IDDAT(JS+2)    = TYPE         : type of input signal:            ISTAB4     53
CD                                     = 1 rotor speed                  ISTAB4     54
CD                                     = 2 acceleration power           ISTAB4     55
CD                                     = 3 bus frequency                ISTAB4     56
CD                                     = 4 electrical power             ISTAB4     57
CD                                     = 5 bus voltage magnitude        ISTAB4     58
CD                                     = 6 voltage deviation from steadyISTAB4     59
CD                                        state value                   ISTAB4     60
CD     DDAT(JS+ 3)    = KS                                              ISTAB4     61
CD     DDAT(JS+ 4)    = T5                                              ISTAB4     62
CD     DDAT(JS+ 5)    = T1                                              ISTAB4     63
CD     DDAT(JS+ 6)    = T2                                              ISTAB4     64
CD     DDAT(JS+ 7)    = T3                                              ISTAB4     65
CD     DDAT(JS+ 8)    = T4                                              ISTAB4     66
CD     DDAT(JS+ 9)    = VSMAX                                           ISTAB4     67
CD     DDAT(JS+10)    = VSMIN                                           ISTAB4     68
CD     DDAT(JS+11)    = TF                                              ISTAB4     69
CD     DDAT(JS+12)    = RC                                              ISTAB4     70
CD     DDAT(JS+13)    = XC                                              ISTAB4     71
CD     DDAT(JS+14)    = PTHR                                            ISTAB4     72
CD     DDAT(JS+15)    = KANG                                            ISTAB4     73
CD     DDAT(JS+16)    = TANG                                            ISTAB4     74
CD     DDAT(JS+17)    = DWTHR                                           ISTAB4     75
CD     DDAT(JS+18)    = EIHR                                            ISTAB4     76
CD     DDAT(JS+19)    = VS3MX                                           ISTAB4     77
CD     DDAT(JS+20)    = VS3MN                                           ISTAB4     78
CD     DDAT(JS+21)    = VANGM                                           ISTAB4     79
CD     DDAT(JS+22)    = VANGMX                                          ISTAB4     80
CD                                                                      ISTAB4     81
CD     Stabilizer states                                                ISTAB4     82
CD                                                                      ISTAB4     83
CD     XSTATE(JSS+1)  = TF block if input is bus frequency              ISTAB4     84
CD                                                  : optional          ISTAB4     85
CD     XSTATE(JSS+2)  = T5 block                    : compulsory        ISTAB4     86
CD     XSTATE(JSS+3)  = first state of T2/T4 block  : optional          ISTAB4     87
CD     XSTATE(JSS+4)  = second state of T2/T4 block : optional          ISTAB4     88
CD     XSTATE(JSS+5)  = TANG block                       : compulsory   ISTAB4     89
CD                                                                      ISTAB4     90
CD     Stabilizer Y-variables                                           ISTAB4     91
CD                                                                      ISTAB4     92
CD     VSS(JYS+1)     = stabilizer output                               ISTAB4     93
CD                                                                      ISTAB4     94
CD   4.6 Stabilizer type 6                                              ISTAB4     95
CD                                                                      ISTAB4     96
CD     Stabilizer data                                                  ISTAB4     97
CD                                                                      ISTAB4     98
CD     IDDAT(JS+1)    = BUSR         : sensing bus number               ISTAB4     99
CD     IDDAT(JS+2)    = TYPE         : type of input signal:            ISTAB4    100
CD                                     = 1 rotor speed                  ISTAB4    101
CD                                     = 2 acceleration power           ISTAB4    102
CD                                     = 3 bus frequency                ISTAB4    103
CD                                     = 4 electrical power             ISTAB4    104
CD                                     = 5 bus voltage magnitude        ISTAB4    105
CD                                     = 6 voltage deviation from steadyISTAB4    106
CD                                        state value                   ISTAB4    107
CD     DDAT(JS+ 3)    = KS                                              ISTAB4    108
CD     DDAT(JS+ 4)    = T5                                              ISTAB4    109
CD     DDAT(JS+ 5)    = T1                                              ISTAB4    110
CD     DDAT(JS+ 6)    = T2                                              ISTAB4    111
CD     DDAT(JS+ 7)    = T3                                              ISTAB4    112
CD     DDAT(JS+ 8)    = T4                                              ISTAB4    113
CD     DDAT(JS+ 9)    = VSMAX                                           ISTAB4    114
CD     DDAT(JS+10)    = VSMIN                                           ISTAB4    115
CD     DDAT(JS+11)    = TF                                              ISTAB4    116
CD     DDAT(JS+12)    = RC                                              ISTAB4    117
CD     DDAT(JS+13)    = XC                                              ISTAB4    118
CD     DDAT(JS+14)    = PTHR                                            ISTAB4    119
CD     DDAT(JS+15)    = KANG                                            ISTAB4    120
CD     DDAT(JS+16)    = TANG                                            ISTAB4    121
CD     DDAT(JS+17)    = DWTHR                                           ISTAB4    122
CD     DDAT(JS+18)    = ETHR                                            ISTAB4    123
CD     DDAT(JS+19)    = VS3MX                                           ISTAB4    124
CD     DDAT(JS+20)    = VS3MN                                           ISTAB4    125
CD     DDAT(JS+21)    = VANGM                                           ISTAB4    126
CD     DDAT(JS+22)    = VANGMX                                          ISTAB4    127
CD                                                                      ISTAB4    128
CD     Stabilizer states                                                ISTAB4    129
CD                                                                      ISTAB4    130
CD     XSTATE(JSS+1)  = TF block if input is bus frequency              ISTAB4    131
CD                                                  : optional          ISTAB4    132
CD     XSTATE(JSS+2)  = T5 block                    : compulsory        ISTAB4    133
CD     XSTATE(JSS+3)  = first state of T2/T4 block  : optional          ISTAB4    134
CD     XSTATE(JSS+4)  = second state of T2/T4 block : optional          ISTAB4    135
CD     XSTATE(JSS+5)  = TANG block                       : compulsory   ISTAB4    136
CD                                                                      ISTAB4    137
CD     Stabilizer Y-variables                                           ISTAB4    138
CD                                                                      ISTAB4    139
CD     VSS(JYS+1)     = stabilizer output                               ISTAB4    140
CD                                                                      ISTAB4    141
CD   4.7 Stabilizer type 7                                              ISTAB4    142
CD                                                                      ISTAB4    143
CD     Not functional                                                   ISTAB4    144
CD                                                                      ISTAB4    145
      INCLUDE 'PARX.INS'                                                ISTAB4    146
      INCLUDE 'CNMDAT.INS'                                              ISTAB4    147
      INCLUDE 'CNB1.INS'                                                ISTAB4    148
      INCLUDE 'CNB4.INS'                                                ISTAB4    149
      INCLUDE 'CNSTN.INS'                                               ISTAB4    150
      INCLUDE 'CNXSTA.INS'                                              ISTAB4    151
      INCLUDE 'CNEXC.INS'                                               ISTAB4    152
      INCLUDE 'CNYVAR.INS'                                              ISTAB4    153
      INCLUDE 'CNIMPR.INS'                                              ISTAB4    154
      INCLUDE 'CNUNIT.INS'                                              ISTAB4    155
      INCLUDE 'CNMSG.INS'                                               ISTAB4    156
C                                                                       ISTAB4    157
      DATA BIG/99.9/                                                    ISTAB4    158
C                                                                       ISTAB4    159
C   TYPE 7 STABILIZER                                                   ISTAB4    160
C                                                                       ISTAB4    161
C                                                                       ISTAB4    162
C  INPUT TIME CONSTANTS CHECK AND RESET                                 ISTAB4    163
C                                                                       ISTAB4    164
      IF (ISTABN.EQ.7) THEN                                             ISTAB4    165
         IF(DDAT(JS+4).LT.TMIN)THEN                                     ISTAB4    166
            WRITE(MSG(1),9040) NLF,INAME(KN-2),INAME(KN-1),INAME(KN)    ISTAB4    167
     *                        ,NDGC(N)                                  ISTAB4    168
            WRITE(MSG(2),9020) 'TW',DDAT(JS+4),TMIN                     ISTAB4    169
            CALL PRTMSG(2)                                              ISTAB4    170
            MSG(1)='STABILIZER DATA ERROR'                              ISTAB4    171
            CALL ASTOP(MSG(1),21)                                       ISTAB4    172
         ENDIF                                                          ISTAB4    173
         IF (IDDAT(JS+7).EQ.0.AND.IDDAT(JS+8).EQ.0) THEN                ISTAB4    174
            DDAT(JS+7)=BIG                                              ISTAB4    175
            DDAT(JS+8)=-BIG                                             ISTAB4    176
         END IF                                                         ISTAB4    177
         ISMAX=JS+7                                                     ISTAB4    178
         ISMIN=JS+8                                                     ISTAB4    179
         KSTATE=KSTATE+1                                                ISTAB4    180
         IDDAT(JS+1)=JSTATE+KSTATE                                      ISTAB4    181
         XSTATE(JSTATE+KSTATE)=DDAT(JS+3)*PDGN                          ISTAB4    182
      ELSE                                                              ISTAB4    183
C                                                                       ISTAB4    184
C   TYPE 4,5 & 6 STABILIZERS                                            ISTAB4    185
C                                                                       ISTAB4    186
         IF (IDDAT(JS+2).EQ.0) IDDAT(JS+2)=1                            ISTAB4    187
C                                                                       ISTAB4    188
         IF(DDAT(JS+4).LT.TMIN)THEN                                     ISTAB4    189
            WRITE(MSG(1),9040) NLF,INAME(KN-2),INAME(KN-1),INAME(KN)    ISTAB4    190
     *                        ,NDGC(N)                                  ISTAB4    191
            WRITE(MSG(2),9020) 'T5',DDAT(JS+4),TMIN                     ISTAB4    192
            CALL PRTMSG(2)                                              ISTAB4    193
            MSG(1)='STABILIZER DATA ERROR'                              ISTAB4    194
            CALL ASTOP(MSG(1),21)                                       ISTAB4    195
         ENDIF                                                          ISTAB4    196
C                                                                       ISTAB4    197
         IF(IDDAT(JS+8).EQ.0)THEN                                       ISTAB4    198
            IF(DDAT(JS+6).LT.TMIN.AND.IDDAT(JS+6).NE.0)THEN             ISTAB4    199
             WRITE(MSG(1),9040) NLF,INAME(KN-2),INAME(KN-1),INAME(KN)   ISTAB4    200
     *                         ,NDGC(N)                                 ISTAB4    201
             WRITE(MSG(2),9020) 'T2',DDAT(JS+6),TMIN                    ISTAB4    202
            IF(MTFLAG.EQ.0) THEN                                        ISTAB4    203
             CALL PRTMSG(2)                                             ISTAB4    204
            ELSE                                                        ISTAB4    205
             WRITE(MSG(3),9030) 'T2',0.                                 ISTAB4    206
             CALL PRTMSG(3)                                             ISTAB4    207
             DDAT(JS+6)=0.0                                             ISTAB4    208
            ENDIF                                                       ISTAB4    209
            ENDIF                                                       ISTAB4    210
         ELSEIF(DDAT(JS+8).LT.TMIN)THEN                                 ISTAB4    211
            WRITE(MSG(1),9000) NLF,INAME(KN-2),INAME(KN-1),INAME(KN)    ISTAB4    212
     *                        ,NDGC(N)                                  ISTAB4    213
            WRITE(MSG(2),9020) 'T4',DDAT(JS+8),TMIN                     ISTAB4    214
            IF(MTFLAG.EQ.0) THEN                                        ISTAB4    215
             CALL PRTMSG(2)                                             ISTAB4    216
            ELSE                                                        ISTAB4    217
            WRITE(MSG(3),9030) 'T4',0.                                  ISTAB4    218
             CALL PRTMSG(3)                                             ISTAB4    219
             DDAT(JS+8)=0.0                                             ISTAB4    220
            ENDIF                                                       ISTAB4    221
            IF(DDAT(JS+6).LT.TMIN.AND.IDDAT(JS+6).NE.0)THEN             ISTAB4    222
               WRITE(MSG(1),9000) NLF,INAME(KN-2),INAME(KN-1),INAME(KN) ISTAB4    223
     *                           ,NDGC(N)                               ISTAB4    224
               WRITE(MSG(2),9020) 'T2',DDAT(JS+6),TMIN                  ISTAB4    225
               IF(MTFLAG.EQ.0) THEN                                     ISTAB4    226
                 CALL PRTMSG(2)                                         ISTAB4    227
               ELSE                                                     ISTAB4    228
                 WRITE(MSG(3),9030) 'T2',0.                             ISTAB4    229
                 CALL PRTMSG(3)                                         ISTAB4    230
                 DDAT(JS+6)=0.0                                         ISTAB4    231
               ENDIF                                                    ISTAB4    232
            ENDIF                                                       ISTAB4    233
         ENDIF                                                          ISTAB4    234
C                                                                       ISTAB4    235
         IF(DDAT(JS+16).LT.TMIN.AND.IDDAT(JS+16).NE.0.AND.              ISTAB4    236
     *        ISTABN.NE.4)THEN                                          ISTAB4    237
            WRITE(MSG(1),9000) NLF,INAME(KN-2),INAME(KN-1),INAME(KN)    ISTAB4    238
     *                        ,NDGC(N)                                  ISTAB4    239
            WRITE(MSG(2),9020) 'TANG',DDAT(JS+16),TMIN                  ISTAB4    240
            IF(MTFLAG.EQ.0) THEN                                        ISTAB4    241
              CALL PRTMSG(2)                                            ISTAB4    242
            ELSE                                                        ISTAB4    243
              WRITE(MSG(3),9030) 'TANG',0.                              ISTAB4    244
              CALL PRTMSG(3)                                            ISTAB4    245
              DDAT(JS+16)=0.0                                           ISTAB4    246
            ENDIF                                                       ISTAB4    247
         ENDIF                                                          ISTAB4    248
C                                                                       ISTAB4    249
         IF (ISTABN.EQ.4) THEN                                          ISTAB4    250
            IDDAT(JS+15)=0                                              ISTAB4    251
            IDDAT(JS+16)=0                                              ISTAB4    252
         ELSE                                                           ISTAB4    253
            IDDAT(JS+25)=0                                              ISTAB4    254
            IDDAT(JS+26)=0                                              ISTAB4    255
            IDDAT(JS+27)=0                                              ISTAB4    256
         END IF                                                         ISTAB4    257
C                                                                       ISTAB4    258
         IF (IDDAT(JS+6).EQ.0) IDDAT(JS+5)=0                            ISTAB4    259
         IF (IDDAT(JS+8).EQ.0) IDDAT(JS+7)=0                            ISTAB4    260
         ISMAX=JS+9                                                     ISTAB4    261
         ISMIN=JS+10                                                    ISTAB4    262
C                                                                       ISTAB4    263
         KSTATE=KSTATE+1                                                ISTAB4    264
         XSTATE(JSTATE+KSTATE)=DDAT(JS+3)*VSI1                          ISTAB4    265
         IF (IDDAT(JS+6).EQ.0.AND.IDDAT(JS+8).EQ.0) GOTO 100            ISTAB4    266
         IF (IDDAT(JS+8).NE.0) THEN                                     ISTAB4    267
            KSTATE=KSTATE+2                                             ISTAB4    268
            XSTATE(JSTATE+KSTATE-1)=0.0                                 ISTAB4    269
            XSTATE(JSTATE+KSTATE)=0.0                                   ISTAB4    270
            IF (ISTABN.EQ.4) THEN                                       ISTAB4    271
               IDDAT(JS+15)=JSTATE+KSTATE-1-NSTATE                      ISTAB4    272
               IDDAT(JS+16)=JSTATE+KSTATE-NSTATE                        ISTAB4    273
            ELSE                                                        ISTAB4    274
               IDDAT(JS+25)=JSTATE+KSTATE-1-NSTATE                      ISTAB4    275
               IDDAT(JS+26)=JSTATE+KSTATE-NSTATE                        ISTAB4    276
            END IF                                                      ISTAB4    277
         ELSE                                                           ISTAB4    278
            KSTATE=KSTATE+1                                             ISTAB4    279
            XSTATE(JSTATE+KSTATE)=0.0                                   ISTAB4    280
            IF (ISTABN.EQ.4) THEN                                       ISTAB4    281
               IDDAT(JS+15)=JSTATE+KSTATE-NSTATE                        ISTAB4    282
            ELSE                                                        ISTAB4    283
               IDDAT(JS+25)=JSTATE+KSTATE-NSTATE                        ISTAB4    284
            END IF                                                      ISTAB4    285
         END IF                                                         ISTAB4    286
  100    CONTINUE                                                       ISTAB4    287
         IF (ISTABN.NE.4) THEN                                          ISTAB4    288
            KSTATE=KSTATE+1                                             ISTAB4    289
            XSTATE(JSTATE+KSTATE)=0.0                                   ISTAB4    290
            IDDAT(JS+27)=JSTATE+KSTATE-NSTATE                           ISTAB4    291
         END IF                                                         ISTAB4    292
C         YVAR(JYS+3)=0.0                                               ISTAB4    293
C         YVAR(JYS+4)=0.0                                               ISTAB4    294
C         JY=JY+2                                                       ISTAB4    295
      END IF                                                            ISTAB4    296
C                                                                       ISTAB4    297
      JSTATE=JSTATE+KSTATE                                              ISTAB4    298
C                                                                       ISTAB4    299
      RETURN                                                            ISTAB4    300
C                                                                       ISTAB4    301
 9000 FORMAT(' *** WARNING GENERATOR AT BUS: ',I5,' STATION: ',3A4      ISTAB4    302
     *,' GID:',A4)                                                      ISTAB4    303
 9020 FORMAT(5X,'TYPE 4, 5, 6 OR 7 STABILIZER ',A,'=',F8.6              ISTAB4    304
     *,' IS BELOW THE LIMIT VALUE OF ',F4.2)                            ISTAB4    305
 9030 FORMAT(5X,A,' HAS BEEN SET TO ',F4.2)                             ISTAB4    306
 9040 FORMAT(' *** DATA ERROR GENERATOR AT BUS: ',I5,' STATION: ',3A4   ISTAB4    307
     *,' GID:',A4)                                                      ISTAB4    308
      END                                                               ISTAB4    309
